<template>
  <!-- https://www.figma.com/file/7VSzbmcT5GFyarcwu495md/Issuer-Portal?node-id=0%3A1 -->
  <AppMainCard
    :is-loading="isChecking"
    text-root="requestCredentials"
    :type="type"
  >
    <RegistrationFeedback
      v-if="fail"
      :button-text="$t('requestCredentials.newLink')"
      text-root="requestCredentials.infoCard"
      @click="navigateTo('/registration')"
    />
    <div v-if="!fail" class="w-full md:w-3/4">
      <div v-if="successStepOne" class="flex flex-col">
        <AppFlexCenterLayout column>
          <h1 class="mb-5 text-3xl font-black">
            {{ $t("requestCredentials.stepOneSubTitle") }}
          </h1>
        </AppFlexCenterLayout>
        <IssuanceForm
          v-if="successStepOne && !successStepTwo"
          v-model="credentialSubject"
          :errors="formErrors"
          :required-credentials="requiredCredentials"
        />
        <AppFlexCenterLayout v-if="successStepTwo">
          <AppInfoCard
            class="w-4/5"
            :alert-type="successWarn"
            text-root="requestCredentials.infoCard"
          />
        </AppFlexCenterLayout>
        <div v-else class="justify-center card-actions">
          <AppButton
            class="w-3/5"
            :display-text="$t('requestCredentials.issueCredential')"
            :is-loading="loading"
            @click="issueCredential"
          />
        </div>
      </div>
      <SSIFormSelection
        v-else
        v-model="ssiWallet"
        class="max-w-[20rem] m-auto"
        :loading="loading"
        success
        @click="sendForm"
      />
    </div>
  </AppMainCard>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import useVuelidate, { ErrorObject } from '@vuelidate/core'
import { required } from '@vuelidate/validators'
import { ICredentialSubject } from '~/components/IssuanceForm.vue'
import { AlertType } from '~/utility/constant'

type CredentialSubjectKeys = keyof ICredentialSubject
export default defineComponent({
  name: 'RequestCredentialsPage',
  setup() {
    return { v$: useVuelidate() }
  },
  data() {
    return {
      loading: false,
      isChecking: true,
      successStepOne: false,
      successStepTwo: false,
      fail: false,
      ssiWallet: '',
      baseURI: this.$config.baseURI_issuer,
      token: '',
      formErrors: [] as ErrorObject[],
      formHasError: false,
      validForm: false,
      credentialSubject: {
        hasLegallyBindingName: '',
        hasRegistrationNumber: '',
        hasCountry: '',
        id: '',
        hasJurisdiction: '',
        leiCode: '',
        ethereumAddress: ''
      } as ICredentialSubject,
      onboardingToken: '',
      sessionId: ''
    }
  },
  validations() {
    return {
      credentialSubject: {
        hasLegallyBindingName: { required },
        hasRegistrationNumber: { required },
        hasCountry: { required },
        id: { required },
        hasJurisdiction: { required }
      }
    }
  },
  computed: {
    type() {
      if (this.successStepOne) {
        return AlertType.SUCCESS
      }
      if (this.fail) {
        return AlertType.ERROR
      }
      return AlertType.DEFAULT
    },
    requiredCredentials() {
      const keys = Object.keys(this.credentialSubject as ICredentialSubject)
      return keys.filter(key => {
        if (!(this.v$ as any).credentialSubject?.[key]) { return false }
        return Object.prototype.hasOwnProperty.call((this.v$ as any).credentialSubject?.[key], 'required')
      })
    },
    successWarn() {
      return AlertType.SUCCESS
    }
  },
  created() {
    this.isChecking = true
    const { activation_link: activationLink, sessionId } = this.$route.query
    if (sessionId) {
      this.sessionId = String(sessionId)
    }
    const baseURI = 'https://issuer-api.lab.gaia-x.eu'

    const url = `${baseURI}/mails/${activationLink}`
    const requestOptions = {
      method: 'GET',
      headers: { 'Content-Type': 'application/json' }
    }

    fetch(url, requestOptions) // TODO update backend and then update this
      .then(async response => {
        const { isValidLink } = await response.json()
        this.onboardingToken = String(activationLink)
        this.fail = !isValidLink
      })
      .catch(() => {
        this.fail = true
      })
      .finally(() => {
        this.isChecking = false
      })
  },
  methods: {
    sendForm() {
      if (this.successStepOne || this.ssiWallet === '') {
        return
      }
      this.successStepOne = true
    },
    issueCredential() {
      this.v$.$touch()
      this.formErrors = (this.v$ as any).credentialSubject.$errors
      this.formHasError = (this.v$ as any).$error
      if (this.formHasError) { return }

      this.loading = true
      const url = 'https://issuer-api.lab.gaia-x.eu/credentials/issue'

      const payload:any = {
        credentialSubject: this.removeEmptyCredentialFields(),
        onboardingToken: this.onboardingToken
      }

      if (this.sessionId) {
        payload.sessionId = this.sessionId
      }

      const requestOptions = {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify(payload)
      }

      fetch(url, requestOptions)
        .then(response => response.json())
        .then(data => {
          if (!data.redirectUrl) { throw new Error('Invalid Token') }
          window.open(data.redirectUrl)
          this.successStepTwo = true
        })
        .catch(() => {
          this.fail = true
        })
        .finally(() => {
          this.loading = false
        })
    },
    removeEmptyCredentialFields() {
      const output: ICredentialSubject = { ...this.credentialSubject }
      Object.keys(output).forEach(key => {
        if (output[key as CredentialSubjectKeys] === '') {
          delete output[key as CredentialSubjectKeys]
        }
      })
      return output
    }
  }
})
</script>
